#!/usr/bin/perl
#
# Centurion v2.0a
# by ak[id] // LimpidByte
# http://lbyte.void.ru
# 
## "Centurion" was made to check CGI scripts on remote server for vulnerabilities such as:
# traversal bug, null byte, incorrect filtering of meta characters.  
# Tested on CGI/PL, PHP, SHTML.
#
## What "Centurion" doesn't support: 
# - At the moment it works only with UNIX alike systems 
#   (Doesnt find anything on win32 based servers (obviously  :) ) ).
# - Doesnt work with scripts which generate FRAMES for output results.
#
## Changes made:
# - Multihost scanning added
# - User Agent faker added
# - IIS filter added
# - Simpler way to specify targets
# - Opportunity to enter specific port for each host
# - Some small bugs fixed
#
# > Settings can be found in config.pl
# > Examples (with explanation) stored in data.example
#
# Please send BUG REPORTS to static@id.ru
# Enjoy >)
#
######################################################

require "conf.pl";
use IO::Socket;

unless(@ARGV > 1) { &usage; }
$opt=$ARGV[0];

if ($opt eq "-m") { 
	open (MASS, "<$ARGV[1]") || die "Can't open $ARGV[1]\n";
	&logcheck;
	while ($url=<MASS>) {
		chomp ($url);
		check ($url);
	}
	&finish;
} elsif ($opt eq "-s") { 
		$url = $ARGV[1];
		&logcheck;
		check ($url);
		&finish;
} else { &usage; }


sub check {
	my ($url)=@_;
	my ($host, $port, $path, $params, $param, @path, @params, $error, $no_params);
	
	$url=~s /http:\/\/// if ($url=~/http:\/\//);
 	
	($host, @path) = split (/\//, $url);
	($addr, $port)=split(/:/, $host);
	$port="80" if (!$port);
	
	$path="/".join("/", @path);
	($path, $params) = split (/\?/, $path);
	@params = split  (/,/, $params);
	
	$error = serv_check ($addr, $port, $path);
	
	if (!$error){
		if ($params[0] eq "") { $no_params=1; @params="lbyte"; }
		foreach $param (@params) {
		script_check ($addr, $port, $path, $param, $no_params);			
		}
	}  
	
}


sub serv_check {
	my ($addr, $port, $path)=@_;
	my ($sock, $error, $srv, @serv);
	$error=0;
	
	### Connecting to host
	print "\n\nConnecting to $addr: ";
	
	$sock = IO::Socket::INET->new(
	Proto => "tcp",
	PeerAddr => $addr,
	PeerPort => $port);
	
	if (!$sock) {
		$error=1; 
		print "Could't connect\n";
		next;
	}
	
	if (not $error) {
		print "OK\n";
		print $sock "GET $path HTTP/1.0\nHost: $addr\n" . $faker[int(rand($#faker))];
		@serv=<$sock>;
		close ($sock);
		
		###  Check for script existance
		print "Checking script: ";
		if ($serv[0] =~ /200/) { 
			print "OK\n";
		} elsif ($serv[0] =~ /404/) { 
			print "Script not found\n";
			$error=1; 
			if ($opt eq "-m") {next} else {&finish;}
		} else {
			print " Unknown replay from server\n";
		}
		
		###  IIS filter
		print "Checking web server: ";	
		foreach (@serv){
			if (/^server:/i){
				$_ =~ s/\r//g;
				$srv=$_;
			} 
		}
		if ($srv =~ /IIS/) {
			print "Web server seems to be IIS, no point to check\n";
			if ($iisskip) {
    			$error=1;
    			if ($opt eq "-m") {next} else {&finish;}
			}
		} elsif (!$srv) { 
			print "Unknown\n"; 
		} else { 
			print "OK\n";
		}
		
		open (LOGS, ">>$log") || die "Can't Create LOGS file\n";
		print LOGS "\n\nResults for $addr:\n";
		print LOGS "-" x 11 ."\n";
		
	}
	
	return ($error);
}
		
sub script_check {
	my ($addr, $port, $path, $param, $no_params)=@_;
	my ($parametr, $req, @request, $sock, @data, $dat, $i, $m, $count, $ok);

	chop ($param) if (substr ($param, length ($param)-1, 1) eq "=");
	$parametr = "$param"."=";
	$parametr = "" if ($no_params);

	print "\n=> trying $path?$parametr\n";
	
	open (BASE, "<base") || die "Can't open BASE with requests\n";
	chomp(@request=<BASE>);
	close BASE;
	
	foreach $req (@request) {
	
    	$count = $ok = 0;

		while ($ok == 0) {
    		$sock = IO::Socket::INET->new(
        	Proto => "tcp",
        	PeerAddr => $addr,
        	PeerPort => $port);
    		
			if ($sock) {
	    		print $sock "GET $path"."?"."$parametr"."$req HTTP/1.0\nHost: $addr\n" . $faker[int(rand($#faker))];
   	    		
		@data=<$sock>;
            	chomp(@data);
            	close ($sock);	
    		
	    		foreach $dat (@data) {
	    			$i="0";
	    			foreach $m (keys %match) {
	    				if ($dat =~ m/$m/i) {
	    					print "$match{$m}";
    						 
	    					open (LOGS, ">>$log") || die "Can't open LOGS\n";
	    					print LOGS "$addr$path?$parametr$req\n";
	    					close LOGS;
	    					 
	    					$i="1";
	    				}
	    			} 
	    			if ($i) {last;} else { next;}
	    		}
			print ".";
			$ok=1;
	
			} else {
				$count++;
				print "\ncan't connect to $addr on $port port\n";
				print "Sleeping for $sleep seconds ...\n";
				select (undef, undef, undef, $sleep);
				print "Continuing\n";
				
				$ok=1 if ($count==$conlimit);
				
			}
		}
		
	}
}


sub finish {
		print "\n\n"."="x 60 ."\n=== FINISHED ===\n";
		exit;
}

sub logcheck {
	if (-e $log)  { 
		&ver; 
	} else {
		open (LOGS, ">$log") || die "Can't Create LOGS file\n";
		print LOGS "Centurion log File:\n"."=" x 20;
		print LOGS "\n";
		close LOGS;
		&ver;
	}
}


sub ver {
		print "=" x 60 . "\n";
		print "Centurion v2.0a\n";
		print "http://lbyte.void.ru/\n";
		print "=" x 60;
}


sub usage {
	print "USAGE:\n";
	print "$0 -m datafile\n";
	print "$0 -s www.yorhost.com:80/cgi-bin/script.cgi?temp,file,show\n";
	exit;
}